import type { HistorySnapshot } from './history';
import { AbstractHistory } from './history';
export interface ReadOnlyHistoryOptions {
    /**
     * Initial ref, defaults to '/'.
     */
    initialRef?: string;
    /**
     * URL prefix.
     */
    prefix?: string;
}
export declare class ReadOnlyHistory<TData = any> extends AbstractHistory<number, TData> {
    readonly snapshot: HistorySnapshot<number, TData>;
    private prefix;
    constructor({ initialRef, prefix }?: ReadOnlyHistoryOptions);
    getHRefByRef(ref: string): string;
    getRefByHRef(href: string): string;
    back(): Promise<void>;
    forward(): Promise<void>;
    push(): Promise<void>;
    replace(): Promise<void>;
    restore(): Promise<void>;
}
