"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteMatch = exports.ROUTE_SERVICE_EXTENSION_SYMBOL = exports.ROUTE_SERVICE_UPDATE_DATA_SYMBOL = exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL = void 0;
const tslib_1 = require("tslib");
const mobx_1 = require("mobx");
const _utils_1 = require("../@utils");
const route_match_shared_1 = require("./route-match-shared");
exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL = Symbol('enter data');
exports.ROUTE_SERVICE_UPDATE_DATA_SYMBOL = Symbol('update data');
exports.ROUTE_SERVICE_EXTENSION_SYMBOL = Symbol('extension');
class RouteMatch extends route_match_shared_1.RouteMatchShared {
    constructor(name, router, source, parent, extension, history, { exact, ...sharedOptions }) {
        super(name, router, source, parent, history, sharedOptions);
        Object.defineProperty(this, "$next", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /** @internal */
        Object.defineProperty(this, "_beforeEnterCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_beforeUpdateEntrySet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_beforeLeaveCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_willEnterCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_willUpdateEntrySet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_willLeaveCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_enterCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_updateEntrySet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_leaveCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_afterEnterCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_afterUpdateEntrySet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_afterLeaveCallbackSet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_reactiveEntrySet", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        /** @internal */
        Object.defineProperty(this, "_service", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /** @internal */
        Object.defineProperty(this, "_servicePromise", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /** @internal */
        Object.defineProperty(this, "_serviceFactory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /** @internal */
        Object.defineProperty(this, "_allowExact", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /** @internal */
        Object.defineProperty(this, "_parallel", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        if (extension) {
            for (const key of Object.keys(extension)) {
                Object.defineProperty(this, key, {
                    get() {
                        const service = this.$matched ? this._service : undefined;
                        if (service) {
                            if (key in service) {
                                let value = service[key];
                                if (typeof value === 'function') {
                                    value = value.bind(service);
                                }
                                return value;
                            }
                            else {
                                const serviceExtension = service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL];
                                if (serviceExtension && key in serviceExtension) {
                                    return serviceExtension[key];
                                }
                            }
                        }
                        return extension[key];
                    },
                });
            }
        }
        this._allowExact = exact;
    }
    $beforeEnter(callback) {
        this._beforeEnterCallbackSet.add(callback);
        return () => {
            this._beforeEnterCallbackSet.delete(callback);
        };
    }
    $beforeUpdate(callback, options) {
        const entry = {
            callback,
            options,
        };
        this._beforeUpdateEntrySet.add(entry);
        return () => {
            this._beforeUpdateEntrySet.delete(entry);
        };
    }
    $beforeLeave(callback) {
        this._beforeLeaveCallbackSet.add(callback);
        return () => {
            this._beforeLeaveCallbackSet.delete(callback);
        };
    }
    $willEnter(callback) {
        this._willEnterCallbackSet.add(callback);
        return () => {
            this._willEnterCallbackSet.delete(callback);
        };
    }
    $willUpdate(callback, options) {
        const willUpdateEntry = {
            callback,
            options,
        };
        this._willUpdateEntrySet.add(willUpdateEntry);
        return () => {
            this._willUpdateEntrySet.delete(willUpdateEntry);
        };
    }
    $willLeave(callback) {
        this._willLeaveCallbackSet.add(callback);
        return () => {
            this._willLeaveCallbackSet.delete(callback);
        };
    }
    $enter(callback) {
        this._enterCallbackSet.add(callback);
        return () => {
            this._enterCallbackSet.delete(callback);
        };
    }
    $update(callback, options) {
        const updateEntry = {
            callback,
            options,
        };
        this._updateEntrySet.add(updateEntry);
        return () => {
            this._updateEntrySet.delete(updateEntry);
        };
    }
    $leave(callback) {
        this._leaveCallbackSet.add(callback);
        return () => {
            this._leaveCallbackSet.delete(callback);
        };
    }
    $afterEnter(callback) {
        this._afterEnterCallbackSet.add(callback);
        return () => {
            this._afterEnterCallbackSet.delete(callback);
        };
    }
    $afterUpdate(callback, options) {
        const afterUpdateEntry = {
            callback,
            options,
        };
        this._afterUpdateEntrySet.add(afterUpdateEntry);
        return () => {
            this._afterUpdateEntrySet.delete(afterUpdateEntry);
        };
    }
    $afterLeave(callback) {
        this._afterLeaveCallbackSet.add(callback);
        return () => {
            this._afterLeaveCallbackSet.delete(callback);
        };
    }
    $autorun(view, options) {
        const autorunEntry = {
            type: 'autorun',
            view,
            options,
            disposer: undefined,
        };
        this._reactiveEntrySet.add(autorunEntry);
        if (this.$matched) {
            (0, _utils_1.tolerate)(() => {
                autorunEntry.disposer = (0, mobx_1.autorun)(view, options);
            });
        }
        return () => {
            if (autorunEntry.disposer) {
                autorunEntry.disposer();
                autorunEntry.disposer = undefined;
            }
            this._reactiveEntrySet.delete(autorunEntry);
        };
    }
    $reaction(expression, effect, options) {
        const reactionEntry = {
            type: 'reaction',
            expression,
            effect,
            options,
            disposer: undefined,
        };
        this._reactiveEntrySet.add(reactionEntry);
        if (this.$matched) {
            (0, _utils_1.tolerate)(() => {
                reactionEntry.disposer = (0, mobx_1.reaction)(expression, effect, options);
            });
        }
        return () => {
            if (reactionEntry.disposer) {
                reactionEntry.disposer();
                reactionEntry.disposer = undefined;
            }
            this._reactiveEntrySet.delete(reactionEntry);
        };
    }
    $beforeEnterOrUpdate(callback, beforeUpdateOptions) {
        const beforeUpdateEntry = {
            callback,
            options: beforeUpdateOptions,
        };
        this._beforeEnterCallbackSet.add(callback);
        this._beforeUpdateEntrySet.add(beforeUpdateEntry);
        return () => {
            this._beforeEnterCallbackSet.delete(callback);
            this._beforeUpdateEntrySet.delete(beforeUpdateEntry);
        };
    }
    $willEnterOrUpdate(callback, willUpdateOptions) {
        const willUpdateEntry = {
            callback,
            options: willUpdateOptions,
        };
        this._willEnterCallbackSet.add(callback);
        this._willUpdateEntrySet.add(willUpdateEntry);
        return () => {
            this._willEnterCallbackSet.delete(callback);
            this._willUpdateEntrySet.delete(willUpdateEntry);
        };
    }
    $afterEnterOrUpdate(callback, afterUpdateOptions) {
        const afterUpdateEntry = {
            callback,
            options: afterUpdateOptions,
        };
        this._afterEnterCallbackSet.add(callback);
        this._afterUpdateEntrySet.add(afterUpdateEntry);
        return () => {
            this._afterEnterCallbackSet.delete(callback);
            this._afterUpdateEntrySet.delete(afterUpdateEntry);
        };
    }
    $service(factory) {
        if (this._serviceFactory) {
            throw new Error(`Service has already been defined for "${this.$name}"`);
        }
        this._serviceFactory = factory;
        return this;
    }
    $parallel(options) {
        if (this.$group) {
            throw new Error('Parallel whitelist can only be set on primary routes');
        }
        const { groups = [], matches = [] } = options;
        const parent = this.$parent;
        if (parent instanceof RouteMatch && parent._parallel) {
            const { groups: parentGroups = [], matches: parentMatches = [] } = parent._parallel;
            const parentGroupSet = new Set(parentGroups);
            const parentMatchSet = new Set(parentMatches);
            const groupsBeingSubsetOfParents = groups.every(group => parentGroupSet.has(group));
            if (!groupsBeingSubsetOfParents) {
                throw new Error("Parallel group can only be a subset of its parent's groups");
            }
            const matchesBeingSubsetOfParents = matches.every(match => {
                if (typeof match.$group === 'string' &&
                    parentGroupSet.has(match.$group)) {
                    return true;
                }
                let current = match;
                while (current) {
                    if (parentMatchSet.has(current)) {
                        return true;
                    }
                    current = current.$parent;
                }
                return false;
            });
            if (!matchesBeingSubsetOfParents) {
                throw new Error("Parallel match can only be a subset of its parent's matches");
            }
        }
        this._parallel = options;
        const children = this._children || [];
        for (const child of children) {
            if (child._parallel &&
                (!parent || parent._parallel !== child._parallel)) {
                throw new Error('Parallel options can only be specified in a top-down fashion');
            }
            child.$parallel(options);
        }
    }
    $match(path) {
        const parent = this.$parent;
        let upperRest;
        if (parent) {
            const { matched, rest } = parent.$match(path);
            if (!matched) {
                return {
                    matched: false,
                    exactlyMatched: false,
                    rest: '',
                };
            }
            upperRest = rest;
        }
        else {
            upperRest = path;
        }
        const { matched, exactlyMatched, rest } = this._match(upperRest);
        return { matched, exactlyMatched, rest };
    }
    /** @internal */
    _match(upperRest) {
        const pattern = this._matchPattern;
        let segment;
        let rest;
        if (typeof pattern === 'string') {
            if ((0, _utils_1.testPathPrefix)(upperRest, pattern)) {
                segment = pattern;
                rest = upperRest.slice(pattern.length);
                if (rest.startsWith('/')) {
                    rest = rest.slice(1);
                }
            }
            else {
                segment = undefined;
                rest = '';
            }
        }
        else {
            const groups = pattern.exec(upperRest);
            if (groups) {
                const matched = groups[0];
                if ((0, _utils_1.testPathPrefix)(upperRest, matched)) {
                    segment = matched;
                    rest = upperRest.slice(matched.length);
                    if (rest.startsWith('/')) {
                        rest = rest.slice(1);
                    }
                }
                else {
                    segment = undefined;
                    rest = '';
                }
            }
            else {
                segment = undefined;
                rest = '';
            }
        }
        let matched = segment !== undefined;
        let exactlyMatched = matched && rest === '';
        if (exactlyMatched) {
            const allowExact = this._allowExact;
            if (typeof allowExact === 'string') {
                // Specify a default rest path on an exact match.
                rest = allowExact;
            }
            else if (this._children && !allowExact) {
                // If this route has children and does not allow exact match, then this
                // match is invalid and reset `matched` and `exactlyMatched` to false.
                matched = false;
                exactlyMatched = false;
            }
        }
        return {
            matched,
            exactlyMatched,
            segment,
            rest,
        };
    }
    /** @internal */
    async _beforeLeave() {
        const results = await Promise.all([
            ...Array.from(this._beforeLeaveCallbackSet).map(callback => (0, _utils_1.tolerate)(callback)),
            (async () => {
                const service = this._getServiceSync();
                if (service && service.beforeLeave) {
                    return (0, _utils_1.tolerate)(() => service.beforeLeave());
                }
            })(),
        ]);
        return !results.some(result => result === false);
    }
    /** @internal */
    async _beforeEnter() {
        const next = this.$next;
        const results = await Promise.all([
            ...Array.from(this._beforeEnterCallbackSet).map(callback => (0, _utils_1.tolerate)(callback, next)),
            (async () => {
                const service = await this._getService();
                if (service && service.beforeEnter) {
                    const ret = await (0, _utils_1.tolerate)(() => service.beforeEnter(next));
                    if (typeof ret === 'object') {
                        service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL] = ret;
                        return undefined;
                    }
                    else {
                        return ret;
                    }
                }
            })(),
        ]);
        return !results.some(result => result === false);
    }
    /** @internal */
    async _beforeUpdate(triggeredByDescendants) {
        const next = this.$next;
        const results = await Promise.all([
            ...Array.from(this._beforeUpdateEntrySet)
                .filter(({ options }) => triggeredByDescendants ? options && options.traceDescendants : true)
                .map(({ callback }) => (0, _utils_1.tolerate)(callback, next, { descendants: triggeredByDescendants })),
            (async () => {
                const service = this._getServiceSync();
                if (service && service.beforeUpdate) {
                    const ret = await (0, _utils_1.tolerate)(() => service.beforeUpdate(next, { descendants: triggeredByDescendants }));
                    if (typeof ret === 'object') {
                        service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL] = ret;
                        return undefined;
                    }
                    else {
                        return ret;
                    }
                }
            })(),
        ]);
        return !results.some(result => result === false);
    }
    /** @internal */
    async _willLeave() {
        for (const reactiveEntry of this._reactiveEntrySet) {
            if (reactiveEntry.disposer) {
                reactiveEntry.disposer();
                reactiveEntry.disposer = undefined;
            }
        }
        await Promise.all([
            ...Array.from(this._willLeaveCallbackSet).map(callback => (0, _utils_1.tolerate)(callback)),
            (async () => {
                const service = this._getServiceSync();
                if (service && service.willLeave) {
                    return (0, _utils_1.tolerate)(() => service.willLeave());
                }
            })(),
        ]);
    }
    /** @internal */
    async _willEnter() {
        const next = this.$next;
        await Promise.all([
            ...Array.from(this._willEnterCallbackSet).map(callback => (0, _utils_1.tolerate)(callback, next)),
            (async () => {
                const service = this._getServiceSync();
                if (service && service.willEnter) {
                    const extension = await (0, _utils_1.tolerate)(() => service.willEnter(next, service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL]));
                    if (extension) {
                        service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL] = extension;
                    }
                }
            })(),
        ]);
    }
    /** @internal */
    async _willUpdate(triggeredByDescendants) {
        const next = this.$next;
        await Promise.all([
            ...Array.from(this._willUpdateEntrySet)
                .filter(({ options }) => triggeredByDescendants ? options && options.traceDescendants : true)
                .map(({ callback }) => (0, _utils_1.tolerate)(callback, next, { descendants: triggeredByDescendants })),
            (async () => {
                const service = this._getServiceSync();
                if (service && service.willUpdate) {
                    const extension = await (0, _utils_1.tolerate)(() => service.willUpdate(next, { descendants: triggeredByDescendants }, service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL]));
                    if (extension) {
                        service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL] = extension;
                    }
                }
            })(),
        ]);
    }
    /** @internal */
    _abortEnterUpdate() {
        const service = this._getServiceSync();
        if (service) {
            delete service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL];
        }
    }
    /** @internal */
    _enter() {
        for (const callback of this._enterCallbackSet) {
            (0, _utils_1.tolerate)(callback);
        }
        const service = this._getServiceSync();
        if (service) {
            const data = service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL];
            delete service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL];
            if (service.enter) {
                const extension = (0, _utils_1.tolerate)(() => service.enter(data));
                if (extension) {
                    service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL] = extension;
                }
            }
        }
        for (const reactiveEntry of this._reactiveEntrySet) {
            if (reactiveEntry.disposer) {
                reactiveEntry.disposer();
                console.warn('Unexpected disposer during enter phase.');
            }
            (0, _utils_1.tolerate)(() => {
                switch (reactiveEntry.type) {
                    case 'autorun':
                        reactiveEntry.disposer = (0, mobx_1.autorun)(reactiveEntry.view, reactiveEntry.options);
                        break;
                    case 'reaction':
                        reactiveEntry.disposer = (0, mobx_1.reaction)(reactiveEntry.expression, reactiveEntry.effect, reactiveEntry.options);
                        break;
                }
            });
        }
    }
    /** @internal */
    _update(triggeredByDescendants) {
        var _a;
        for (const { options, callback } of this._updateEntrySet) {
            if (triggeredByDescendants && !((_a = options === null || options === void 0 ? void 0 : options.traceDescendants) !== null && _a !== void 0 ? _a : false)) {
                continue;
            }
            (0, _utils_1.tolerate)(callback, { descendants: triggeredByDescendants });
        }
        const service = this._getServiceSync();
        if (service) {
            const data = service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL];
            delete service[exports.ROUTE_SERVICE_ENTER_UPDATE_DATA_SYMBOL];
            if (service.update) {
                const extension = (0, _utils_1.tolerate)(() => service.update({ descendants: triggeredByDescendants }, data));
                if (extension) {
                    service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL] = extension;
                }
            }
        }
    }
    /** @internal */
    _leave() {
        for (const callback of this._leaveCallbackSet) {
            (0, _utils_1.tolerate)(callback);
        }
        const service = this._getServiceSync();
        if (service) {
            if (service.leave) {
                (0, _utils_1.tolerate)(() => service.leave());
            }
            delete service[exports.ROUTE_SERVICE_EXTENSION_SYMBOL];
        }
    }
    /** @internal */
    async _afterLeave() {
        for (const callback of this._afterLeaveCallbackSet) {
            (0, _utils_1.tolerate)(callback);
        }
        const service = this._getServiceSync();
        if (service && service.afterLeave) {
            (0, _utils_1.tolerate)(() => service.afterLeave());
        }
    }
    /** @internal */
    async _afterEnter() {
        for (const callback of this._afterEnterCallbackSet) {
            (0, _utils_1.tolerate)(callback);
        }
        const service = this._getServiceSync();
        if (service && service.afterEnter) {
            (0, _utils_1.tolerate)(() => service.afterEnter());
        }
    }
    /** @internal */
    async _afterUpdate(triggeredByDescendants) {
        for (const { callback, options } of this._afterUpdateEntrySet) {
            if (triggeredByDescendants ? options && options.traceDescendants : true) {
                (0, _utils_1.tolerate)(callback, { descendants: triggeredByDescendants });
            }
        }
        const service = this._getServiceSync();
        if (service && service.afterUpdate) {
            (0, _utils_1.tolerate)(() => service.afterUpdate({ descendants: triggeredByDescendants }));
        }
    }
    /** @internal */
    _getMatchEntry(source) {
        const matchToMatchEntryMap = source.groupToMatchToMatchEntryMapMap.get(this.$group);
        return matchToMatchEntryMap && matchToMatchEntryMap.get(this);
    }
    /** @internal */
    _getBuilder() {
        return this.$router.$current;
    }
    /** @internal */
    async _getService() {
        const serviceOrServicePromise = this._service || this._servicePromise;
        if (serviceOrServicePromise) {
            return serviceOrServicePromise;
        }
        const factory = this._serviceFactory;
        if (!factory) {
            return undefined;
        }
        const output = (0, _utils_1.tolerate)(factory, this);
        if (output instanceof Promise) {
            return (this._servicePromise = output.then(service => {
                this._service = service;
                return service;
            }));
        }
        else {
            this._service = output;
            return output;
        }
    }
    /** @internal */
    _getServiceSync() {
        const service = this._service;
        if (service) {
            return service;
        }
        if (this._servicePromise) {
            throw new Error(`Service of route ${this.$name} is not ready: either use synchronous service factory or make sure the service is ready earlier`);
        }
        const factory = this._serviceFactory;
        if (!factory) {
            return undefined;
        }
        const output = (0, _utils_1.tolerate)(factory, this);
        if (output instanceof Promise) {
            this._servicePromise = output.then(service => {
                this._service = service;
                return service;
            });
            throw new Error(`Service of route ${this.$name} is not ready: either use synchronous service factory or make sure the service is ready earlier`);
        }
        else {
            this._service = output;
            return output;
        }
    }
}
Object.defineProperty(RouteMatch, "SEGMENT", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: /[^/]+/
});
Object.defineProperty(RouteMatch, "REST", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: /.*/
});
tslib_1.__decorate([
    mobx_1.observable
], RouteMatch.prototype, "_service", void 0);
exports.RouteMatch = RouteMatch;
//# sourceMappingURL=route-match.js.map